import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.Version;

@Entity 
public class Professor {
    @Id private int id;
    private String name;
    private long salary;
    private int vacationDays;
    @Version private int version;
    @ManyToOne(cascade={CascadeType.REFRESH})
    private Professor manager;
    

    public int getId() {
        return id;
    }
    
    public void setId(int id) {
        this.id = id;
    }
    
    public String getName() {
        return name;
    }
    
    public void setName(String name) {
        this.name = name;
    }
    
    public long getSalary() {
        return salary;
    }
    
    public void setSalary(long salary) {
        this.salary = salary;
    }
    
    public int getVacationDays() {
        return vacationDays;
    }

    public void setVacationDays(int vacation) {
        this.vacationDays = vacation;
    }

    
    public Professor getManager() {
        return manager;
    }
    
    public void setManager(Professor manager) {
        this.manager = manager;
    }

    public String toString() {
        return "Professor id: " + getId() + " name: " + getName() +
               " vacation: " + getVacationDays() + " salary: " + getSalary();
    }
}
